#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")

STATIC lVISTA := .F.

PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIService
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"AddressWidth",;
"Architecture",;
"Availability",;
"Caption",;
"ConfigManagerErrorCode",;
"ConfigManagerUserConfig",;
"CpuStatus",;
"CreationClassName",;
"CurrentClockSpeed",;
"CurrentVoltage",;
"DataWidth",;
"Description",;
"DeviceID",;
"ErrorCleared",;
"ErrorDescription",;
"ExtClock",;
"Family",;
"InstallDate",;
"L2CacheSize",;
"L2CacheSpeed",;
"LastErrorCode",;
"Level",;
"LoadPercentage",;
"Manufacturer",;
"MaxClockSpeed",;
"Name",;
"NumberOfCores",;
"NumberOfLogicalProcessors",;
"OtherFamilyDescription",;
"PNPDeviceID",;
"PowerManagementCapabilities",;
"PowerManagementSupported",;
"ProcessorId",;
"ProcessorType",;
"Revision",;
"Role",;
"SocketDesignation",;
"Status",;
"StatusInfo",;
"Stepping",;
"SystemCreationClassName",;
"SystemName",;
"UniqueId",;
"UpgradeMethod",;
"Version" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_Processor.TXT
   SET ALTER ON

   IF "VISTA" $ OS(OS_PRODUCT) .OR. "WIN2003" $ OS(OS_PRODUCT) .OR. "WIN2008" $ OS(OS_PRODUCT)
      lVISTA := .T.
   ENDIF
   IF lVISTA
      IF strComputer == "Localhost"
         objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIService  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIService:ExecQuery("select * from Win32_Processor",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("AddressWidth"),;
     oService:getProperty("Architecture"),;
     oService:getProperty("Availability"),;
     oService:getProperty("Caption"),;
     oService:getProperty("ConfigManagerErrorCode"),;
     oService:getProperty("ConfigManagerUserConfig"),;
     oService:getProperty("CpuStatus"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("CurrentClockSpeed"),;
     oService:getProperty("CurrentVoltage"),;
     oService:getProperty("DataWidth"),;
     oService:getProperty("Description"),;
     oService:getProperty("DeviceID"),;
     oService:getProperty("ErrorCleared"),;
     oService:getProperty("ErrorDescription"),;
     oService:getProperty("ExtClock"),;
     oService:getProperty("Family"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("L2CacheSize"),;
     oService:getProperty("L2CacheSpeed"),;
     oService:getProperty("LastErrorCode"),;
     oService:getProperty("Level"),;
     oService:getProperty("LoadPercentage"),;
     oService:getProperty("Manufacturer"),;
     oService:getProperty("MaxClockSpeed"),;
     oService:getProperty("Name"),;
     oService:getProperty("NumberOfCores"),;
     oService:getProperty("NumberOfLogicalProcessors"),;
     oService:getProperty("OtherFamilyDescription"),;
     oService:getProperty("PNPDeviceID"),;
     oService:getProperty("PowerManagementCapabilities"),;
     oService:getProperty("PowerManagementSupported"),;
     oService:getProperty("ProcessorId"),;
     oService:getProperty("ProcessorType"),;
     oService:getProperty("Revision"),;
     oService:getProperty("Role"),;
     oService:getProperty("SocketDesignation"),;
     oService:getProperty("Status"),;
     oService:getProperty("StatusInfo"),;
     oService:getProperty("Stepping"),;
     oService:getProperty("SystemCreationClassName"),;
     oService:getProperty("SystemName"),;
     oService:getProperty("UniqueId"),;
     oService:getProperty("UpgradeMethod"),;
     oService:getProperty("Version") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? jMax := LEN(aItem)
      ? iMax := LEN(aItem[1])
?"*****************************************************************************"
      FOR j := 1 TO jMax
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT

?"*****************************************************************************"

      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_Processor.TXT","Notepad.exe",.T.)

RETURN
